package com.hxhq.system.mapper;

import java.util.List;

import com.hxhq.business.dto.select.BzListDto;
import com.hxhq.business.dto.select.DeptUserTreeDto;
import org.apache.ibatis.annotations.Param;
import com.hxhq.system.api.domain.SysUser;

/**
 * 用户表 数据层
 * 
 * @author hxhq
 */
public interface SysUserMapper
{
    /**
     * 根据条件分页查询用户列表
     * 
     * @param sysUser 用户信息
     * @return 用户信息集合信息
     */
    public List<SysUser> selectUserList(SysUser sysUser);

    /**
     * 获取用户的角色
     * @param userIdList
     * @return
     */
    public List<SysUser> selectUserRoleNames(@Param("userIdList") List<Long> userIdList);

    /**
     * 根据条件分页查询已配用户角色列表
     * 
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    public List<SysUser> selectAllocatedList(SysUser user);

    /**
     * 根据条件分页查询未分配用户角色列表
     * 
     * @param user 用户信息
     * @return 用户信息集合信息
     */
    public List<SysUser> selectUnallocatedList(SysUser user);

    /**
     * 通过用户名查询用户
     * 
     * @param userName 用户名
     * @return 用户对象信息
     */
    public SysUser selectUserByUserName(String userName);

    /**
     * 通过用户ID查询用户
     * 
     * @param userId 用户ID
     * @return 用户对象信息
     */
    public SysUser selectUserById(Long userId);

    /**
     * 新增用户信息
     * 
     * @param user 用户信息
     * @return 结果
     */
    public int insertUser(SysUser user);

    /**
     * 修改用户信息
     * 
     * @param user 用户信息
     * @return 结果
     */
    public int updateUser(SysUser user);

    /**
     * 修改用户头像
     * 
     * @param userId 用户ID
     * @param avatar 头像地址
     * @return 结果
     */
    public int updateUserAvatar(@Param("userId") Long userId, @Param("avatar") String avatar);

    /**
     * 修改用户状态
     * 
     * @param userId 用户ID
     * @param status 状态
     * @return 结果
     */
    public int updateUserStatus(@Param("userId") Long userId, @Param("status") String status);

    /**
     * 更新用户登录信息（IP和登录时间）
     * 
     * @param user 用户信息
     * @return 结果
     */
    public int updateLoginInfo(SysUser user);

    /**
     * 重置用户密码
     * 
     * @param userId 用户ID
     * @param password 密码
     * @return 结果
     */
    public int resetUserPwd(@Param("userId") Long userId, @Param("password") String password);

    /**
     * 通过用户ID删除用户
     * 
     * @param userId 用户ID
     * @return 结果
     */
    public int deleteUserById(Long userId);

    /**
     * 批量删除用户信息
     * 
     * @param userIds 需要删除的用户ID
     * @return 结果
     */
    public int deleteUserByIds(Long[] userIds);

    /**
     * 校验用户名称是否唯一
     * 
     * @param userName 用户名称
     * @return 结果
     */
    public SysUser checkUserNameUnique(String userName);

    /**
     * 校验手机号码是否唯一
     *
     * @param phonenumber 手机号码
     * @return 结果
     */
    public SysUser checkPhoneUnique(String phonenumber);

    /**
     * 校验email是否唯一
     *
     * @param email 用户邮箱
     * @return 结果
     */
    public SysUser checkEmailUnique(String email);

    /**
     * 获取所有用户的简要信息
     * @return
     */
    List<SysUser> selectTransferAllList();

    /**
     * 获取角色已分配的用户id
     * @param roleId
     * @return
     */
    List<Long> selectAllocatedListSimple(Long roleId);

    /**
     * 获取部门+人员列表
     * @return
     */
    List<DeptUserTreeDto> selectDeptAndUser();

    /**
     * 获取试验人员列表
     * @param studyId
     * @param studySubjectId
     * @param deptId
     * @param permit
     * @return
     */
    List<DeptUserTreeDto> selectStudyUser(@Param("studyId") Long studyId, @Param("studySubjectId") Long studySubjectId,@Param("deptId") Long deptId, @Param("permit") String permit);

    /**
     * 获取新增试验方法需要通知的用户ID
     * @param studyId
     * @param studySubjectId
     * @param deptId
     * @param createUserId
     * @return
     */
    List<Long> selectStudyMethodUserIdExcludeCreate(@Param("studyId") Long studyId, @Param("studySubjectId") Long studySubjectId,@Param("deptId") Long deptId,@Param("createUserId") Long createUserId);

    /**
     * 获取部长列表
     * @return
     */
    List<BzListDto> selectBzList();

    /**
     * 根据用户id获取用户姓名
     * @param idList
     * @return
     */
    List<String> selectNamesByIdList(@Param("idList") List<Long> idList);
}
